/*****************************************************************************
 * bf518f_s25fl116k_dpia.c
 *****************************************************************************/

#include <sys/platform.h>
#include <services/int/adi_sid.h>
#include "common/flash.h"
#include "common/spi.h"

static const char *pEzKitTitle = "ADSP-BF518F EZ-Board";

extern const struct spi_ctlr adi_spi_bf5xx_ctlr;
extern struct flash_info s25fl116k_info;

static void dpia_init(void)
{
	spi_ctlr = &adi_spi_bf5xx_ctlr;
	flash_info = &s25fl116k_info;

	/* Set up pinmux.  This can be removed when pinmux add-in
	   is available for BF518.  */

#define SPI_SPI0_PORTG_MUX  ((uint16_t) ((uint16_t) 0<<14))

#define SPI_SCK_PORTG_FER  ((uint16_t) ((uint16_t) 1<<12))
#define SPI_MISO_PORTG_FER  ((uint16_t) ((uint16_t) 1<<13))
#define SPI_MOSI_PORTG_FER  ((uint16_t) ((uint16_t) 1<<14))

	/* PORTx_MUX registers */
	*pPORTG_MUX = SPI_SPI0_PORTG_MUX;

	/* PORTx_FER registers */
	*pPORTG_FER = SPI_SCK_PORTG_FER | SPI_MISO_PORTG_FER
			| SPI_MOSI_PORTG_FER;

	/* We use GPIO PG15 as external SPI flash /CS.
	   We cannot use slave select since using it requires set CPHA to 1,
	   but we want CPHA 0.  */
	//*pPORTG_FER &= 0x7fff;
	//*pPORTGIO_DIR |= 0x8000;

	/*Use PH8 for internal SPI chip select -DJH */

	*pPORTH_FER &= ~(PH8);
	*pPORTHIO_DIR |= PH8;
}

#include "common/dpia.c"
